# This software is licensed according to the pySLEQP academic license
# see LICENSE

# Exposing the GuRoBi API to cython

cdef extern from "gurobi_c.h":
    ctypedef struct GRBenv:
        pass

    ctypedef struct GRBmodel:
        pass

    void GRBfreeenv(GRBenv *env)

    char* GRBgeterrormsg(GRBenv *env)

    int GRBfreemodel(GRBmodel *model)

    int GRBloadenv(GRBenv **envP, const char *logfilename)
    
    int GRBnewmodel(GRBenv *env, GRBmodel **modelP, const char *Pname, int numvars,
              double *obj, double *lb, double *ub, char *vtype,
              char **varnames)
    
    int GRBaddconstrs(GRBmodel *model, int numconstrs, int numnz,
                int *cbeg, int *cind, double *cval,
                char *sense, double *rhs, char **constrnames)
                
    int GRBaddrangeconstrs(GRBmodel *model, int numconstrs, int numnz,
                int *cbeg, int *cind, double *cval,
                double *lower, double *upper, char **constrnames)

    int GRBdelconstrs(GRBmodel *model, int len, int *ind)

    int GRBupdatemodel(GRBmodel *model)

    int GRBoptimize(GRBmodel *model)

    int GRBgetdblattr(GRBmodel *model, const char *attrname, double *valueP)

    int GRBgetdblattrarray(GRBmodel *model, const char *attrname, int start, int len, double *values)

    int GRBgetintattr(GRBmodel *model, const char *attrname, int *valueP)

    int GRBgetintattrarray(GRBmodel *model, const char *attrname, int start, int len, int *values)

    int GRBsetdblattrelement(GRBmodel *model, const char *attrname,
                       int element, double newvalue)

    int GRBsetintparam(GRBenv *env, const char *paramname, int value)
    
    int GRBsetdblparam(GRBenv *env, const char *paramname, double value)

    int GRBgetstrattr(GRBmodel *model, const char *attrname, char **valueP)

    int GRBgetstrattrelement(GRBmodel *model, const char *attrname, int element, char **valueP)

    int GRBwrite(GRBmodel *model, const char *filename)

    char* GRB_DBL_ATTR_OBJ
    char* GRB_DBL_ATTR_OBJVAL
    char* GRB_DBL_ATTR_LB
    char* GRB_DBL_ATTR_UB
    char* GRB_INT_ATTR_CBASIS
    char* GRB_DBL_ATTR_SLACK
    char* GRB_INT_ATTR_VBASIS
    int GRB_OPTIMAL
    int GRB_INFEASIBLE
    char* GRB_INT_ATTR_STATUS
    char* GRB_INT_PAR_OUTPUTFLAG
    char* GRB_DBL_ATTR_X
    char* GRB_DBL_ATTR_PI
    char* GRB_INT_PAR_METHOD
    char* GRB_DBL_ATTR_KAPPA
    char* GRB_DBL_PAR_TIMELIMIT
    char* GRB_INT_ATTR_NUMVARS
    char* GRB_STR_ATTR_VARNAME
